window.$ = jQuery
var interval;
var noOfCycles = 1;
var currentView;

$(document).ready(function () {

    //the requests are performed every 3 seconds
    interval = setInterval(function () {

        var ajaxurl = $('#ajax-url').val();
        var data = {
            'action': 'wsol_sms_to_get_updates_from_db_otp',
            'post_type': 'POST',
            'name': 'Get Updates from DB'
        };

        jQuery.post(ajaxurl, data, function (response) {

            response.forEach(updateItems);
            //1 cycle is 3 seconds => 20 cycles is 1 minute => 20*30=600 which is equal to 0.5 hours
            //so for 0.5 hours we will automatically receive callbacks, then it will stop 
            //and it will initiate again on the page refresh            
            noOfCycles = noOfCycles + 1;

            if (noOfCycles === 600) {
               clearInterval(interval);
            }
        }, 'json');
    }, 3000);

    function updateItems(item, index) {

        var _id = item['_id'];
        var cost = item['cost'];
        var status = item['status'];

        var tr = $("#outbox-filter td:contains(" + _id + ")").closest("tr").find("td");

            if (typeof tr[5] != "undefined" && tr[5] != null) {
                if (cost != null) {
                    tr[5].innerHTML = cost;
                }
            }
            if (typeof tr[6] != "undefined" && tr[6] != null) {
                tr[6].innerHTML = '<span class=' + getStatusRelevantClass(status) + '>' + status + '</span>';
            }
    }
});

/**
 * According to the status we get the relevant class
 * 
 * @author Christodoulou Panikos
 * @email christodoulou.panicos@cytanet.com.cy
 * @return string
 */
function getStatusRelevantClass(status) {

    if ((status === 'SENT') || (status === 'DELIVERED') || (status === 'DONE')) {
        return "sms_to_otp_status_success";
    }
    if ((status === 'FAILED') ||
            (status === 'REJECTED') ||
            (status === 'UNDELIVERED') ||
            (status === 'EXPIRED') ||
            (status === 'UNSUBSCRIBED')) {
        return "sms_to_otp_status_fail";
    }
    if ((status === 'ONGOING') ||
            (status === 'SENDING') ||
            (status === 'QUEUED') ||
            (status === 'SCHEDULED')) {
        return "sms_to_otp_status_processing";

    }
}



