jQuery(document).ready(function ($) {
    // Check the GDPR enabled.
    if ($('#wpsmstootp-gdpr-confirmation').length) {
        if ($('#wpsmstootp-gdpr-confirmation').attr('checked')) {
            $("#wpsmstootp-submit").removeAttr('disabled');
        } else {
            $("#wpsmstootp-submit").attr('disabled', 'disabled');
        }
        $("#wpsmstootp-gdpr-confirmation").click(function () {
            if (this.checked) {
                $("#wpsmstootp-submit").removeAttr('disabled');
            } else {
                $("#wpsmstootp-submit").attr('disabled', 'disabled');
            }
        });
    }

    $("#wpsmstootp-subscribe #wpsmstootp-submit").click(function () {
        $("#wpsmstootp-result").hide();

        var verify = $("#newsletter-form-verify").val();

        subscriber = Array();
        subscriber['name'] = $("#wpsmstootp-name").val();
        subscriber['mobile_phone'] = $("#wpsmstootp-mobile_phone").val();
        subscriber['group_id'] = $("#wpsmstootp-groups").val();
        subscriber['type'] = $('input[name=subscribe_type]:checked').val();

        $("#wpsmstootp-subscribe").ajaxStart(function () {
            $("#wpsmstootp-submit").attr('disabled', 'disabled');
            $("#wpsmstootp-submit").text(wpsmstootp_ajax_object.loading_text);
        });

        $("#wpsmstootp-subscribe").ajaxComplete(function () {
            $("#wpsmstootp-submit").removeAttr('disabled');
            $("#wpsmstootp-submit").text(wpsmstootp_ajax_object.subscribe_text);
        });
        if (subscriber['type'] === 'subscribe') {
            var method = 'POST';
        } else {
            var method = 'DELETE';
        }
        var data_obj = Object.assign({}, subscriber);
        var ajax = $.ajax({
            type: method,
            url: wpsmstootp_ajax_object.ajaxurl,
            data: data_obj
        });
        ajax.fail(function (data) {
            var response = $.parseJSON(data.responseText);
            var message = null;

            if (typeof (response.error) != "undefined" && response.error !== null) {
                message = response.error.message;
            } else {
                message = wpsmstootp_ajax_object.unknown_error;
            }

            $("#wpsmstootp-result").fadeIn();
            $("#wpsmstootp-result").html('<span class="wpsmstootp-message-error">' + message + '</div>');
        });
        ajax.done(function (data) {
            var response = data;
            var message = response.message;

            $("#wpsmstootp-result").fadeIn();
            $("#wpsmstootp-step-1").hide();
            $("#wpsmstootp-result").html('<span class="wpsmstootp-message-success">' + message + '</div>');
            if (subscriber['type'] === 'subscribe' && verify === '1') {
                $("#wpsmstootp-step-2").show();
            }
        });
    });

    $("#wpsmstootp-subscribe #activation").on('click', function () {
        $("#wpsmstootp-result").hide();
        subscriber['activation'] = $("#wpsmstootp-ativation-code").val();

        $("#wpsmstootp-subscribe").ajaxStart(function () {
            $("#activation").attr('disabled', 'disabled');
            $("#activation").text(wpsmstootp_ajax_object.loading_text);
        });

        $("#wpsmstootp-subscribe").ajaxComplete(function () {
            $("#activation").removeAttr('disabled');
            $("#activation").text(wpsmstootp_ajax_object.activation_text);
        });

        var data_obj = Object.assign({}, subscriber);
        var ajax = $.ajax({
            type: 'PUT',
            url: wpsmstootp_ajax_object.ajaxurl,
            data: data_obj
        });
        ajax.fail(function (data) {
            var response = $.parseJSON(data.responseText);
            var message = null;

            if (typeof (response.error) != "undefined" && response.error !== null) {
                message = response.error.message;
            } else {
                message = wpsmstootp_ajax_object.unknown_error;
            }

            $("#wpsmstootp-result").fadeIn();
            $("#wpsmstootp-result").html('<span class="wpsmstootp-message-error">' + message + '</div>');
        });
        ajax.done(function (data) {
            var response = data;
            var message = response.message;

            $("#wpsmstootp-result").fadeIn();
            $("#wpsmstootp-step-2").hide();
            $("#wpsmstootp-result").html('<span class="wpsmstootp-message-success">' + message + '</div>');
        });
    });
});