<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit;
} // Exit if accessed directly

class WSOL_WP_SMS_TO_OTP {

	public function __construct() {
		/*
		 * Plugin Loaded Action
		 */
		add_action( 'plugins_loaded', array( $this, 'wpsmstootp_plugin_setup' ) );
                add_action( 'init', array( $this, 'wsol_sms_to_otp_update_db' ) );
              
		/**
		 * Install And Upgrade plugin
		 */
		require_once WSOL_WP_SMS_TO_OTP_DIR . 'includes/class-wpsmstootp-install.php';

		register_activation_hook( WSOL_WP_SMS_TO_OTP_DIR . 'wp-sms-to-otp.php', array( '\WSOL_WP_SMS_TO_OTP\Install', 'install' ) );
                
                add_action('init', array( $this, 'redirect_to_general_url_handler' ) );
                    }

	/**
	 * Constructors plugin Setup
	 *
	 * @param Not param
	 */
	public function wpsmstootp_plugin_setup() {
		// Load text domain
		add_action( 'init', array( $this, 'wsol_sms_to_otp_load_textdomain' ) );

		$this->includes();
	}

	/**
	 * Redirect to specific tab
	 * If the page = =wp-sms-to-otp-settings then redirect to tab=general
	 * 
	 */    
        
       public function redirect_to_general_url_handler() {
        if (substr($_SERVER["REQUEST_URI"], -20) == 'page=wp-sms-to-otp-settings') {
            $url = $_SERVER["REQUEST_URI"] . '&tab=general';
            wp_redirect($url);
        }
    }

    /**
	 * Load plugin textdomain.
	 *
	 * @since 1.0.0
	 */
	public function wsol_sms_to_otp_load_textdomain() {           
		load_plugin_textdomain( 'wsol-wp-smsto-otp', false, dirname( plugin_basename( __FILE__ ) ) . '/languages' );
	}

    /**
     * update db on update plugin
     *
     * @since 1.0.0
     */
    public function wsol_sms_to_otp_update_db() {
        require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );

        $installer_wpsms_ver = get_option('sms_to_otp_db_version');

        if ($installer_wpsms_ver < WSOL_WP_SMS_TO_OTP_VERSION) {

            global $wpdb;
            $charset_collate = $wpdb->get_charset_collate();

            // Add response and status for outbox
            $table_name = $wpdb->prefix . 'smstootp_send';
            $column = $wpdb->get_results($wpdb->prepare(
                            "SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA = %s AND TABLE_NAME = %s AND COLUMN_NAME = %s ",
                            DB_NAME, $table_name, 'updated_at'
                    ));

            if (empty($column)) {
                $wpdb->query("ALTER TABLE {$table_name} ADD updated_at DATETIME AFTER date");
            }

            update_option('sms_to_otp_db_version', WSOL_WP_SMS_TO_OTP_VERSION);
        }
    }

    /**
	 * Includes plugin files
	 *
	 * @param Not param
	 */
	public function includes() {

		// Utility classes.
		require_once WSOL_WP_SMS_TO_OTP_DIR . 'includes/class-wpsmstootp-features.php';
                
		if ( is_admin() ) {
			// Admin classes.
			require_once WSOL_WP_SMS_TO_OTP_DIR . 'includes/admin/class-wpsmstootp-admin.php';
			require_once WSOL_WP_SMS_TO_OTP_DIR . 'includes/admin/class-wpsmstootp-admin-helper.php';

			// Outbox class.
			require_once WSOL_WP_SMS_TO_OTP_DIR . 'includes/admin/outbox/class-wpsmstootp-outbox.php';

                        // Login  Register Action  
			require_once WSOL_WP_SMS_TO_OTP_DIR . 'includes/admin/login_register_action/class-wpsmstootp-login_register_action.php';                        
                        
                        
			// Privacy class.
			require_once WSOL_WP_SMS_TO_OTP_DIR . 'includes/admin/privacy/class-wpsmstootp-privacy-actions.php';
                        
			// Documentation class.
			require_once WSOL_WP_SMS_TO_OTP_DIR . 'includes/admin/documentation/class-wpsmstootp-documentation.php';

			// Settings classes.
			require_once WSOL_WP_SMS_TO_OTP_DIR . 'includes/admin/settings/class-wpsmstootp-settings.php';
}
		
		if ( ! is_admin() ) {
			// Front Class.
			require_once WSOL_WP_SMS_TO_OTP_DIR . 'includes/class-front.php';
		}


		// Template functions.
		require_once WSOL_WP_SMS_TO_OTP_DIR . 'includes/template-functions.php';
	}
}