<?php

use WSOL_WP_SMS_TO_OTP\WSOL_SMS_TO_Option;

if ( ! defined( 'ABSPATH' ) ) {
	exit;
} // Exit if accessed directly



/**
 * Get option value.
 *
 * @param $option_name
 * @param bool $pro
 * @param string $setting_name
 *
 * @return string
 */
function sms_to_otp_get_option( $option_name, $pro = false, $setting_name = '' ) {
	return WSOL_SMS_TO_Option::getOption( $option_name, $pro, $setting_name );
}

/**
 * Send SMS.
 *
 * @param array $to
 * @param $msg $pro
 * @param bool $is_flash
 *
 * @param bool $from
 *
 * @return string | WP_Error
 */
function sms_to_otp_send( $to, $msg, $is_flash = false, $from = null ) {
	global $wpsmstootp;

	$wpsmstootp->isflash = $is_flash;
	$wpsmstootp->to      = $to;
	$wpsmstootp->msg     = $msg;

	if ( $from ) {
		$wpsmstootp->from = $from;
	}

	return $wpsmstootp->SendSMS();
}